<?php
/*
Plugin Name: Likno Web Accordion WordPress Plugin
Plugin URI: http://www.likno.com/jquery-accordion/wordpress-accordion.html
Description: WordPress plugin for the Likno Web Accordion Builder - Create stylish, feature-rich accordion controls for your blogs!
Version: 1.1
Author: Likno Software
Author URI: http://www.likno.com/ 
*/

/*

NOTE:

This plugin is licensed under the GNU General Public License (GPL).

As such, you may use the source code of this plugin as you wish.
This plugin is used as a bridge to a non-GPL licensed software (WebAccordionBuilder PRO) that is a property of Likno Software.

The license of Likno Web AccordionBuilder  states that a WordPress accordion can be used in **one single domain**.

Thus, the part of the code below that confirms that the accordion is used only in one domain **cannot** be changed/removed.

*/

global $lwacPluginInstance;
$lwacPluginInstance = new LWAC_Plugin();

class LWAC_Plugin{
    public $optionsMessage, $databaseMessage, $LWAC_ver , $lwac_total_tabs, $wpdb, $dataArray,$lwac_table_name,$lwac_is_loaded,$lwac_toload,$lwac_excluded ;

function LWAC_Plugin(){
    global $wpdb;
    $this->wpdb = $wpdb;

    $this->lwac_toload = array();
    add_action( 'init', array($this,'LWAC_init_hook' ));
    add_action('init', array($this, 'LWAC_addbuttons'));
    //add_action('wp_head', array($this, 'LWAC_head_hook'));
    add_action('admin_menu', array($this, 'LWAC_add_option_pages'));
    add_action('wp_footer',array ($this,'LWAC_generate_linking_code'));
    add_shortcode( 'accordion', array($this, 'LWAC_shortcode') );
    add_action('wp_ajax_lwac_tinymce', array($this, 'lwac_tinymce'));
    add_action( 'admin_init', array($this,'LWAC_addmin_hook' ));
    global $wp_version;
    if((float)$wp_version>=2.8){
        include_once ABSPATH . 'wp-content/plugins/webaccordionbuilder-wordpress-plugin/widgetClass.php';
        add_action('widgets_init', create_function('', 'return register_widget("Widget_WebAccordionBuilder");'));
    }

}

function LWAC_init_hook(){
    global $lwac_table_name, $lwac_total_tabs, $LWAC_ver;
    $this->lwac_table_name = $lwac_table_name = $this->wpdb->prefix . "lwac";
    include_once ABSPATH . 'wp-content/plugins/webaccordionbuilder-wordpress-plugin/include.php';
    wp_enqueue_script( 'jquery' );
    $LWAC_ver = $this->LWAC_ver = '1';


    $this->databaseMessage = lwac_set_first_time_options();
    if (!empty($this->databaseMessage))
                $this->databaseMessage = "<div class=\"updated fade\" style=\"margin-top: 20px;\"><strong>".$this->databaseMessage."</strong></div>";
    $this->lwac_total_tabs = $lwac_total_tabs = $this->wpdb->get_var($this->wpdb->prepare("SELECT COUNT(*) FROM $this->lwac_table_name;",null));
    }

/*
function LWAC_head_hook(){
    global $lwac_table_name, $lwac_total_tabs, $LWAC_ver;
      $load_it = true;
         $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwac_table_name WHERE active = 1 order by id" );
}
*/
/* 
 * Add options page
 */
function LWAC_add_option_pages() {
	if (function_exists('add_options_page')) {
		$page = add_options_page('Likno Web Accordion WordPress Plugin', 'Likno Web Accordion Plugin', 8, __FILE__, array($this,'LWAC_options_page'));
	}
        add_action( 'admin_print_styles-' . $page,  array($this,'LWAC_admin_styles' ));
}

function lwac_wp_settings_link($lwac_links) {
	$lwac_settings_link = '<a href="options-general.php?page=webaccordionbuilder-wordpress-plugin/webaccordionbuilder-wordpress.php">Settings</a>';
	array_unshift($lwac_links, $lwac_settings_link);
	return $lwac_links;
}

/*
 * Initialization of the admin panel.
 */
function LWAC_addmin_hook(){
    if (!session_id()){
                session_start();
                }
                $lwac_plugin = plugin_basename(__FILE__);

       add_filter("plugin_action_links_$lwac_plugin", array($this, 'lwac_wp_settings_link' ));
  /* Register our stylesheet. */
       wp_register_script( 'LWACScript', plugins_url('/script.js', __FILE__) );
       wp_register_script( 'ZeroClipboard', plugins_url('/ZeroClipboard.js', __FILE__) );
       wp_register_style( 'LWACStylesheet', plugins_url('/stylesheet.css',__FILE__ ));
    }

/*
 * Add admin panel styles AND scripts
 */
function LWAC_admin_styles() {
       /*
        * It will be called only on your plugin admin page, enqueue our stylesheet here
        */
       wp_enqueue_style( 'LWACStylesheet' );
       wp_enqueue_script( 'LWACScript' );
       wp_enqueue_script( 'ZeroClipboard' );
   }
/* 
 * Generate options page
 */
function LWAC_options_page() {       
?>
<script type="text/javascript">

                                                ZeroClipboard.setMoviePath( '<?php echo plugins_url('/ZeroClipboard.swf', __FILE__)?>' );
                                              
</script>
        <div style="max-width: 980px; margin-left: 15px;">

	<span class="wrap">
	<h2>Likno Web Accordion Plugin v<?php echo $this->LWAC_ver; ?></h2>

	<?php
?>
	<?php
        echo $this->databaseMessage;
                if (isset($_SESSION['message'])){
                    echo $_SESSION['message'];
                unset ( $_SESSION['message'] );
                    

                }
                ?>
		<p>For information and updates, please visit: 
		<a href="http://www.likno.com/jquery-accordion/wordpress-accordion.html">http://www.likno.com/jquery-accordion/wordpress-accordion.html</a></p>
		<?php
			/* Display a message in the Options page if the accordion version is outdated
			NOTE: we do not check date as we have to recheck to display the message to the admin */

                if (get_option('LWAC_Check_show')) {
				$LWAC_buildText = LWAC_check();
				if ($LWAC_buildText != '') echo $LWAC_buildText;
				else update_option('LWAC_Check_show', FALSE);
			}
		?>
	</span>
	<br />
        <br />

        <form method="post" enctype="multipart/form-data" id="theform1" name="theform1" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webaccordionbuilder-wordpress-plugin/actions.php"; ?>" >
        <div style="text-align: right;">
            <button class="button" type="button" onclick="theform1.theaction.value='createnew'; theform1.LWAC_selected_tab_c.value=theform.LWAC_selected_tab.value;theform1.submit();">Create New</button>
        <button <?php if ($this->lwac_total_tabs == 1) echo "disabled='disabled'"; ?>class="button" type="button" onclick="theform1.theaction.value='delete';theform1.LWAC_accordion_id.value = eval('theform.LWAC_accordion_id_'+theform.LWAC_selected_tab.value + '.value'); theform1.LWAC_selected_tab_c.value=theform.LWAC_selected_tab.value;theform1.submit();">Delete</button>
        </div>
        <table id="uploader">
		<tr>
                    <td width="250">
                        <strong>Upload compiled ZIP file of your accordion: "<i id="upload_form_accordion_name"></i>"</strong></td>
		<td>
                    <input name="LWAC_files_zip" type="file" />
                    <input type="hidden" name="theaction" value="zip_update"/>
                    <input id="LWAC_selected_tab_c" name="LWAC_selected_tab_c" type="hidden" value="<?php echo get_option('LWAC_selected_tab');?>"/>
                    <input type="hidden" name="LWAC_accordion_id" value=""/>
                    <input type="button" name="zip_update" value="Upload ZIP file" onclick="theform1.LWAC_accordion_id.value = eval('theform.LWAC_accordion_id_'+theform.LWAC_selected_tab.value + '.value');theform1.LWAC_selected_tab_c.value=theform.LWAC_selected_tab.value;theform1.submit();"/>
                     <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
    <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webaccordionbuilder-wordpress-plugin/webaccordionbuilder-wordpress.php"); ?>"/>
                </td>
                </tr>
                <tr>
                    <td width="250">&nbsp;</td>
		<td class="lwac_itemInfo">
                    Select the ZIP file produced by the Likno Web Accordion Builder interface (containing the compiled accordion files). Then click the "Upload ZIP file" button and the accordion files will be added (or updated) online.<br />
		</td>
                </tr>
        </table>
        </form>
        <?php $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwac_table_name" );?>

        <form method="post" enctype="multipart/form-data" id="theform" name="theform" action="<?php echo get_bloginfo('url')."/wp-content/plugins/webaccordionbuilder-wordpress-plugin/actions.php"; ?>" >
            <input type="hidden" name="abspath" value="<?php echo ABSPATH; ?>"/>
            <input type="hidden" name="ref" value="<?php echo admin_url("options-general.php?page=webaccordionbuilder-wordpress-plugin/webaccordionbuilder-wordpress.php"); ?>"/>
            <input id="LWAC_selected_tab" name="LWAC_selected_tab" type="hidden" value="<?php echo get_option('LWAC_selected_tab');?>"/>
	<table>
		<tr>
                    <td width="250">
                        <strong>Online folder for accordion files:</strong>
                    </td>
		<td>
                    <input id="LWAC_accordion_path" name="LWAC_accordion_path" onkeyup="lwac_set_path();" onchange="lwac_set_path();" type="text" size="30" value="<?php echo get_option('LWAC_accordion_path'); ?>"/>&nbsp;&nbsp;(relative to blog's root folder)
                </td>
                </tr>
		<tr>
                    <td width="250">&nbsp;</td>
		<td class="lwac_itemInfo">
			Every time you compile your Likno Web Accordion Builder project you should also upload the produced ZIP file online (see above). Its content (accordion files) are then automatically added by the plugin to this folder.
                                                <br><?php echo get_bloginfo('url');?><span id="LWAC_the_path"><?php echo get_option('LWAC_accordion_path');?></span>
                                                <br>(note: you might need to create this online folder yourself)
		</td>
                </tr>
	</table>
	
	<div class="submit" style="text-align: right;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwac_form_validate();"/>
	
	</div>
	<div id="LWAC_tab_wrapper">
		<div id="LWAC_tabHeaders">
<?php 
	for ($lwac=0; $lwac<$this->lwac_total_tabs; $lwac++) {
		echo "<div class='lwac_tab_header' style='color: #".($myrows[$lwac]->active ?"0099":"9900")."00;' id='LWAC_tab_header_$lwac' onclick='lwac_show_tab($lwac)'>". $myrows[$lwac]->name ."</div>";
	}
?>
		</div>
		<div id="LWAC_tabBodies">
<?php 
	for ($lwac=0; $lwac<$this->lwac_total_tabs; $lwac++) {
?>
                    <div class='lwac_tab_body' id='LWAC_tab_body_<?php echo $lwac;?>'>
				<div>
                                    <input type="hidden" name="LWAC_accordion_id_<?php echo $lwac;?>" value="<?php echo $myrows[$lwac]->id?>"/>
                                    <input id="LWAC_accordion_active_<?php echo $lwac;?>" name="LWAC_accordion_active_<?php echo $lwac;?>" onclick="lwac_uncheck(<?php echo $lwac;?>);" type="checkbox" value="true" <?php if( $myrows[$lwac]->active) echo "checked='checked'"; ?> /> <strong>Show "<span id="lwac_active_name_<?php echo $lwac?>"><?php echo $myrows[$lwac]->name;?></span>" in blog</strong>
				&nbsp;&nbsp;&nbsp;<?php if (!$myrows[$lwac]->active) { ?><span id='LWAC_unchecked_<?php echo $lwac;?>' style='color:#990000;'>Unchecked! (this accordion will not appear in your blog)</span><?php } else { ?><span id='LWAC_unchecked_<?php echo $lwac;?>' style='color:#009900;'>(this accordion will appear in your blog)</span><?php } ?>
                                </div>
				<div style="padding-left: 19px; margin-top: 13px;"><strong>accordion name: </strong> <input maxlength="256" onkeyup="lwac_name_change(<?php echo $lwac;?>, this.value);" onchange="lwac_name_change(<?php echo $lwac;?>, this.value);" id="LWAC_accordion_name_<?php echo $lwac;?>"name="LWAC_accordion_name_<?php echo $lwac;?>" type="text" size="30" value="<?php echo $myrows[$lwac]->name ?>" original="<?php echo $myrows[$lwac]->name ?>"/><span class="lwac_name_notice" id="lwac_name_notice_<?php echo $lwac;?>"></span></div>
				<div style="padding-left: 19px;" class="lwac_itemInfo">Please make sure that the "accordion name" value matches the value in the "Compiled Javascript Project" property of your Likno Web Accordion Builder project file (<i>Tools > Project Properties > Compile Properties</i>). <a href="javascript:void(0)" onclick="lwac_folder_info('',<?php echo $lwac;?>);">show me</a></div>
				<div id="LWAC_folder_info_<?php echo $lwac;?>" style="margin-top: 20px; display: none; background-color: #FEFCF5; border: #E6DB55 solid 1px;">
					<table>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 10px; padding-bottom: 10px;">
                                                        <strong>More info</strong> - <a href="javascript:void(0)" onclick="lwac_folder_info('none',<?php echo $lwac;?>);">close</a>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webaccordionbuilder-wordpress-plugin/accordionname.jpg" alt="Project Name" title="Project Name"/>
                                                        <br />
                                                        Compiled Javascript Project (see <span style="color: red;">1</span>) and accordion name (see <span style="color: red;">2</span>) must be the same
                                                        <br />
                                                        <img src="<?php echo get_bloginfo('url');?>/wp-content/plugins/webaccordionbuilder-wordpress-plugin/accordionnamesec.jpg" alt="Accordion Name" title="Accordion Name"/>
                                                    </td>
                                                </tr>
						<tr>
                                                    <td style="width: 800px; text-align: center; padding-top: 0px; padding-bottom: 10px;">
							<a href="javascript:void(0)" onclick="lwac_folder_info('none',<?php echo $lwac;?>);">close</a>
                                                            </td>
                                                </tr>
                                        </table>
				</div>
                                <br />
                                <div>
                                     <fieldset id="lwac_type_fieldset_<?php echo $lwac;?>">
                                    <input onclick="lwac_print_div(this.checked,<?php echo $lwac?>);" type="checkbox" name="lwac_type_<?php echo $lwac?>" value="embedded" <?php checked( $myrows[$lwac]->print_div, 1 ) ?> /> <strong>Print 'DIV' element</strong><br />
                                    <div id="lwac_embeddedDetails_<?php echo $lwac?>" <?php if ( $myrows[$lwac]->print_div ==  0 ) :?> style="display: none" <?php endif;?>>A 'DIV' element will be produced with this id: <input readonly type="text" id="lwac_divname<?php echo $lwac?>" value="lwacAnchor-<?php echo $myrows[$lwac]->name?>" style="width: 200px;"/>
                                        <button class="button" type="button" id="lwac_copy_button_<?php echo $lwac?>">Copy</button>
                                       </div>
                                </fieldset>
                                </div>
                                <br />
                                <div class="LWAC_section">Accordion Positioning Method</div>
                                <div style="padding: 20px 0;">Please select an accordion position where you want your accordion to appear:
				<select style="margin-left: 20px;" onchange="lwac_accordion_position(this.value , <?php echo $lwac;?>)" name="lwac_accordion_position_<?php echo $lwac;?>" id="lwac_accordion_position_<?php echo $lwac;?>">
                                            <option value="shortcode" <?php selected( isset( $myrows[$lwac]->position ) && $myrows[$lwac]->position == "shortcode" ); ?>>shortcode</option>
                                            <option value="template_tag" <?php selected( isset( $myrows[$lwac]->position ) && $myrows[$lwac]->position == "template_tag" ); ?>>template tag</option>
                                            <?php global $wp_registered_sidebars;
                                            global $wp_version;
                                            if ((float)$wp_version>=2.2 &&  count($wp_registered_sidebars > 1)):?>
                                            <option value="lwac_widget" <?php selected( isset( $myrows[$lwac]->position ) && $myrows[$lwac]->position == "lwac_widget" ); ?>>widget</option>
                                            <?php endif;?>
                                        </select>
                                     <div class="lwac_accordion_position" id="lwac_shortcode_position_<?php echo $lwac;?>" <?php if ($myrows[$lwac]->position != 'shortcode') echo 'style="display: none;"';?>>You have selected the <em>’shortcode’</em> positioning method. This means that you can add this accordion inside the post or page that you want, using the visual editor.</div>
                                    <div class="lwac_accordion_position" id="lwac_template_tag_position_<?php echo $lwac;?>" <?php if ($myrows[$lwac]->position !="template_tag") echo 'style="display: none;"';?>>
                                    Copy and paste this code in the template file where you want the accordion to appear.
                                    <br />
                                        <textarea id="template_tag_code_<?php echo $lwac?>" cols="45" rows="5">
&lt;?php if (function_exists('lwac_template_tag'))
    lwac_template_tag('<?php echo $myrows[$lwac]->name?>');?&gt;

                                    </textarea>
                                            <button class="button" type="button" id="lwac_template_tag_button_<?php echo $lwac?>">Copy</button>


                                    </div>
                                    <div class="lwac_accordion_position" id="lwac_widget_position_<?php echo $lwac;?>" <?php if ($myrows[$lwac]->position != "lwac_widget") echo 'style="display: none;"';?>>
                                     You have selected the <em>'Widget'</em> positioning method.
                                        A widget instance for this accordion is initially created and found in the <a href="<?php echo admin_url('widgets.php');?>#wp_inactive_widgets">widgets administration page</a>, under the "Inactive Widgets" section. Just drag this widget instance and drop it inside the Widget Area that you want.</div>

                        </div>
                                </div>
<?php
	}	// end of tab body for loop
?>
		</div>	<!-- tab_bodies -->
	</div>	<!-- tab_wrapper -->
	<br>
	<br>
	<div style="text-align: center;" class="lwac_itemInfo"><span style="color:#990000;">Note:</span> Always click the "Save settings" button below to apply your changes. If you leave this page without saving you will lose your unsaved changes.</div>
	<div class="submit" style="text-align: center;">
		<input type="button" name="info_update" value="Save settings &raquo;" onclick="theform.theaction.value='info_update'; lwac_form_validate();;"/>
	</div>
	
	<input type="hidden" name="theaction" value="" />
	<script type="text/javascript">
            LWAC_TOTAL_TABS_JS = <?php echo $this->lwac_total_tabs?>;
            lwac_show_tab(<?php echo get_option('LWAC_selected_tab'); ?>);
        </script>
	
</form>
</div>	
    <?php

        }	// END of LWAC_options_page()

function LWAC_generate_linking_code() {
    $myrows = $this->wpdb->get_results( "SELECT * FROM $this->lwac_table_name WHERE name in (".  implode(",", $this->lwac_toload).") order by id" );
        $i=0;
        for ($i=0; $i<count($myrows); $i++){
		
		$lwac_name = $myrows[$i]->name;
		
		$output= "<!-- ******** BEGIN LIKNO WEB ACCORDION CODE FOR ".$lwac_name." ******** -->\n";
         $output .= "<script type=\"text/javascript\">var lwacLinkedBy=\"LiknoWebAccordion [1]\",lwacName=\"".$lwac_name."\",lwacBN=\"WP\";</script>\n
                <script charset=\"UTF-8\" src=\"".get_bloginfo('url') . get_option('LWAC_accordion_path').$lwac_name."/".$lwac_name.".js\" type=\"text/javascript\"></script>\n
                 <!-- ******** END LIKNO WEB ACCORDION CODE FOR ".$lwac_name." ******** -->";
        echo $output;
        
        }
}
/* 
 * Initialize query var for sitemap permalinks
 */
function LWAC_query_vars ( $lwac_vars ) {
	$lwac_vars[] = "pg";
	return $lwac_vars;
}

//add_filter('query_vars', 'LWAC_query_vars');
function LWAC_shortcode( $atts ) {
	extract( shortcode_atts( array(
		'name' => 'accordion1',
               'everywhere' => false
	), $atts ) );
        if (!in_array($name, $this->lwac_toload)){
        if (is_singular() || $everywhere){
            $name = $this->wpdb->get_var("SELECT name from $this->lwac_table_name where name = '$name' && position = 'shortcode' and active = 1");
            if (!empty($name)){
            $this->lwac_toload[] = "'".$name."'";

        
        if ($this->wpdb->get_var("SELECT print_div from $this->lwac_table_name where name = '$name' ")== 1){
	return "<span style='display: block;' id='lwacAnchor-$name'></span>";
        }
        else
            return "";
            }
            return "";

        }
        else
        return "";
        }
        else
        return "";
}

function LWAC_addbuttons() {
   // Don't bother doing this stuff if the current user lacks permissions
   if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
     return;

   // Add only in Rich Editor mode
   if ( get_user_option('rich_editing') == 'true') {
     add_filter("mce_external_plugins", array($this, "LWAC_add_tinymce_plugin"));
     add_filter('mce_buttons', array($this, 'LWAC_register_button'));
   }
}

function LWAC_register_button($buttons) {
   array_push($buttons, "|", "lwac");
   return $buttons;
}
// Load the TinyMCE plugin : editor_plugin.js (wp2.5)
function LWAC_add_tinymce_plugin($plugin_array) {
   $plugin_array['lwac'] = get_bloginfo('url').'/wp-content/plugins/webaccordionbuilder-wordpress-plugin/editor_plugin.js';
   return $plugin_array;
}
// init process for button control
function lwac_tinymce(){
    if ( !current_user_can('edit_pages') && !current_user_can('edit_posts') )
    	die(__("You are not allowed to be here"));
   	require_once('LWAC_tinymce.php');
        die();
}
//add_action('loop_start','lwac_floated' );
}

function lwac_template_tag($name){
    global $lwacPluginInstance;
    if ($lwacPluginInstance->wpdb->get_var("SELECT position from $lwacPluginInstance->lwac_table_name where name = '$name' and active = 1 ")=="template_tag"){
        $lwacPluginInstance->lwac_toload[]= "'".$name."'";

        if ($lwacPluginInstance->wpdb->get_var("SELECT print_div from $lwacPluginInstance->lwac_table_name where name = '$name' ")== 1){
            echo "<div id='lwacAnchor-".$name."'></div>";

        }
    }

}
?>